/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// ユーザ登録処理　入力画面表示ビジネスAction
// 
// 
//
//	変更履歴
//	2004.01.08  新規作成 M.Seko
//

package jp.co.ntt.lms.xms.people;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import jp.co.ntt.lms.xmo.Mail.MailConst;
import jp.co.ntt.lms.xms.common.util.CommonUtil;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

/**
 * ユーザ更新処理　入力画面表示ビジネスAction。<br>
 * メニューからユーザ更新を選択した際に、
 * 画面表示を行うために使用する。
 * 
 *  @author M.Seko
 */
public class PeopleUpdateInputFramesetDisplayBusinessAction extends XmsBusinessAction {

	/**
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#initProcessRequest(XmsRequest)
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {
		//もしセッションキー管理クラスのインスタンスが既にセッション中に存在していれば、
		//セッション中の情報を削除する。

		// HTTPセッション取得用
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;
		//セッションキー保持クラスのセッションからの取得試行用
		SKeyKeep skeyKeep = null;
		try {
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			if (session == null) {
				//sessionが無効である場合、処理が続行できないので例外を吐く
				throw new XmsSystemException("This session is invalid.");
			}

			skeyKeep = (SKeyKeep) session.getAttribute(PeopleConst.SKeyKeepSessionKey);

			if (skeyKeep != null) {
				//セッションキー保持クラスが既にセッションに存在している。
				//よって、セッションキー保持クラスが保持しているセッションキーに結びついているデータを削除
				CommonUtil.removeSessionData(xmsRequest, skeyKeep.getSkeyStringArray());
			}

			//元の画面への復帰に必要な情報をセッションに格納する。
			PeopleUpdateComebackInfoBean peopleUpdateComeBackInfoBean = null;
			peopleUpdateComeBackInfoBean = new PeopleUpdateComebackInfoBean();
			peopleUpdateComeBackInfoBean.setReturnURL(request.getParameter("returnURL"));
			session.setAttribute(PeopleConst.ComebackInfoSessionKey, peopleUpdateComeBackInfoBean);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}

	}

	/**
	 * メールの使用可能・不可能に応じて処理を振り分ける。<br>
	 * また、formから入力されるユーザ情報の内容が格納されたセッション情報をクリアにする。<br>
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#processRequest(XmsRequest, XmsResponse)
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse)
		throws XmsException {
		// HTTPセッション取得用
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;

		try {
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			if (session == null) {
				//sessionが無効である場合、処理が続行できないので例外を吐く
				throw new XmsSystemException("This session is invalid.");
			}

			if (CommonUtil.checkMailAuthority(xmsRequest) == true) {
				//ログインユーザは、メール使用可能である
				//メールテンプレート付きの画面を表示するステータスをセットする
				xmsResponse.setBusinessStatus("mailAuthorityOK");

				//メール種別情報をセッションに登録
				session.setAttribute("XMM_MT_MailType", MailConst.TYPE_REGIST);

			} else {
				//ログインユーザは、メール使用不可能である。
				//メールテンプレート無しの画面を表示するステータスをセット
				xmsResponse.setBusinessStatus("mailAuthorityNG");

			}

			//セッションキー保持クラスのセッションからの取得試行及び、セッションへの登録用
			SKeyKeep skeyKeep = null;

			skeyKeep = (SKeyKeep) session.getAttribute(PeopleConst.SKeyKeepSessionKey);
			if (skeyKeep == null) {
				//まだ、セッションキー保持クラスのインスタンスがセッションに存在していない
				//新たに生成する
				skeyKeep = new SKeyKeep();
			}
			//セッションキー保持クラスのインスタンスをセッションに登録
			session.setAttribute(PeopleConst.SKeyKeepSessionKey, skeyKeep);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}

	}

}
